
QGIS Application - Bug report #8317

Deleted features are not really deleted.

2013-07-17 06:58 PM - Minoru Akagi

Status: Closed

Priority: Normal

Assignee:

Category: Data Provider

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 17110

Description

When I save changes of editting to a shapefile after deleting some features, the deleted feature records have not been really deleted from

the shapefile. They are just marked as deleted. With 1.8, they are really deleted. Related to commit:810c11b.

Related issues:

Related to QGIS Application - Bug report # 7472: vector editing errors Closed 2013-03-29

Related to QGIS Application - Bug report # 8822: OGR: Repack in running session Closed 2013-10-11

Related to QGIS Application - Bug report # 11007: Deleted/edited features wit... Closed 2014-08-05

Related to QGIS Application - Bug report # 11296: Deleting shapes in shapefil... Closed 2014-09-30

Associated revisions

Revision 6149d34a - 2013-07-18 10:08 AM - Jürgen Fischer

run REPACK after deleting features (fixes #8317)

Revision cf7e016b - 2014-06-13 10:54 PM - Jürgen Fischer

ogr: don't create spatial index for shapes after deletes. That was supposed to

also run a repack and doesn't work without (fixes #10483, refs #8317, refs #8822)

Revision 7d7cdcd3 - 2015-05-28 12:34 PM - Matthias Kuhn

Repack shapefiles when saving after deleting features

    -  QgsVectorDataProvider::dataChanged() will be emitted

    -  QgsVectorLayer::dataChanged() will be emitted

    -  Clears QgsVectorLayerCache

    -  Reloads the attribute table

    -  Clears the selection

Looking forward to people complaining about their lost selection...

Fix #10560

Fix #11989

Refs #8317

Refs #8822

Refs #10483

Refs #11007
Refs #7540

Refs #11398

Refs #11296

History

#1 - 2013-07-17 11:53 PM - Jürgen Fischer

- Priority changed from Severe/Regression to Normal

you should create a spatialindex once in a while - that will also repack it.

#2 - 2013-07-18 12:09 AM - Minoru Akagi

Users who don't know it will be confused when they move the data to another GIS software. What about doing REPACK in the destructor of

QgsOgrProvider, only if any features have been deleted?

#3 - 2013-07-18 01:19 AM - Jürgen Fischer

- Status changed from Open to Closed

Fixed in changeset commit:"6149d34a5b3d776c582bda5cd3c61ccb15c85f2d".

#4 - 2013-07-18 01:41 AM - Minoru Akagi

Thanks!
